﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />

var animation = undefined;

function ReadSymbol(symbolpath) {
    return new Promise((resolve, reject) => {
        var symbol = new TcHmi.Symbol(symbolpath);
        symbol.readEx(function (data) {
            if (data.error === TcHmi.Errors.NONE) {
                resolve(data.value);
            } else {
                console.log(`error occured in ReadSymbol symbol = ${symbolpath}, error = $ {data.error}`);
                reject(data.error);
            }
        });
    });
}
function WriteSymbol(symbolpath, dataValue) {
    return new Promise((resolve, reject) => {
        TcHmi.Symbol.writeEx(symbolpath, dataValue, function (data) {
            if (data.error === TcHmi.Errors.NONE) {
                resolve(data.value);
            } else {
                console.log(`error occured in WriteSymbol symbol = ${symbolpath}, error = $ {data.error}`);
                reject(data.error);
            }
        });
    });
}


(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    // If you want to unregister an event outside the event code you need to use the return value of the method register()
    var destroyOnInitialized = TcHmi.EventProvider.register('onInitialized', function (e, data) {
        // This event will be raised only once, so we can free resources. 
        // It's best practice to use destroy function of the event object within the callback function to avoid conflicts.
        e.destroy();
        // ----------------------
        // Place your code here!
        // ----------------------
    });
})(TcHmi);
