﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var Subscription;
        (function (Subscription) {
            function YardGateInit() {




                var proximityCloseControl = TcHmi.Controls.get('TcHmiEllipse_GateProximityClosed');
                var proximityOpenControl = TcHmi.Controls.get('TcHmiEllipse_GateProximityOpened');
                var openOutputControl = TcHmi.Controls.get('TcHmiEllipse_OpenOutput');
                var closeOutputControl = TcHmi.Controls.get('TcHmiEllipse_CloseOutput');


                var defaultColor = {
                    color: "rgba(154, 135, 135, 1)" //RED, GREEN, BLUE and ALPHA
                };
                var myColorRed = {
                    color: "rgba(255, 0, 0, 1)" //RED, GREEN, BLUE and ALPHA
                };

                var myColorGreen = {
                    color: 'green'
                };

                if (TcHmi.Server.isWebsocketReady()) {

                    var commands = [
                        {
                            'symbol': 'PLC1.MAIN.fnYardDoor.doorCloseProximitySensor'
                        },
                        {
                            'symbol': 'PLC1.MAIN.fnYardDoor.doorOpenProximitySensor'
                        },
                        {
                            'symbol': 'PLC1.MAIN.fnYardDoor.doorOpeningOutput'
                        },
                        {
                            'symbol': 'PLC1.MAIN.fnYardDoor.doorClosingOutput'
                        }
                    ];

                    TcHmi.Server.subscribe(commands, 1000, function (data) {


                        if (data.error !== TcHmi.Errors.NONE) {
                            console.log(`YardGateInit failed to subscribe data.details.code = ${data.details.code}`);
                            return;
                        }
                        var response = data.response;
                        if (!response || response.error !== undefined) {
                            console.log('YardGateInit wrong response in YardGateInit notification');
                            console.log(`YardGateInit data.details.code = ${data.details.code}`);
                            return;
                        }
                        var commands = response.commands;
                        if (commands === undefined) {
                            console.log('YardGateInit  initialization commands undefined');
                            console.log(`YardGateInit data.details.code = ${data.details.code}`);
                            return;
                        }
                        for (var i = 0; i < commands.length; i++) {
                            var command = commands[i];
                            if (command === undefined) {
                                console.log('YardGateInit  initialization commands undefined');
                                console.log(`YardGateInit data.details.code = ${data.details.code}, symbol = ${command.symbol}`);
                                return;
                            }
                            if (command.error !== undefined) {
                                console.log(commands[i].symbol);
                                console.log('YardGateInit initialization commands  for field devices, error has value, why?');
                                console.log(`YardGateInit data.details.code = ${data.details.code}, symbol = ${command.symbol}`);
                                return;
                            }

                            if (commands[i].symbol.indexOf(".doorCloseProximitySensor") > 0) {
                                console.log('doorCloseProximitySensor');
                                if (command.readValue == true) {
                                    proximityCloseControl.setFillColor(myColorGreen);
                                } else {
                                    proximityCloseControl.setFillColor(defaultColor);
                                }
                            }

                            if (commands[i].symbol.indexOf(".doorOpenProximitySensor") > 0) {
                                console.log('doorOpenProximitySensor');
                                if (command.readValue == true) {
                                    proximityOpenControl.setFillColor(myColorGreen);
                                } else {
                                    proximityOpenControl.setFillColor(defaultColor);
                                }
                            }

                            if (commands[i].symbol.indexOf(".doorOpeningOutput") > 0) {
                                console.log('doorOpeningOutput');
                                if (command.readValue == true) {
                                    openOutputControl.setFillColor(myColorRed);
                                } else {
                                    openOutputControl.setFillColor(defaultColor);
                                }
                            }

                            if (commands[i].symbol.indexOf(".doorClosingOutput") > 0) {
                                console.log('doorClosingOutput');
                                if (command.readValue == true) {
                                    closeOutputControl.setFillColor(myColorRed);
                                } else {
                                    closeOutputControl.setFillColor(defaultColor);
                                }
                            }
                        } //for




                    });
                }
            }
            Subscription.YardGateInit = YardGateInit;
        })(Subscription = Functions.Subscription || (Functions.Subscription = {}));
        Functions.registerFunctionEx('YardGateInit', 'TcHmi.Functions.Subscription', Subscription.YardGateInit);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);